/* Copyright (c) 2002  Michael Stumpf  <mistumpf@de.pepperl-fuchs.com>
   Copyright (c) 2006  Dmitry Xmelkov
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:

   * Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in
     the documentation and/or other materials provided with the
     distribution.
   * Neither the name of the copyright holders nor the names of
     contributors may be used to endorse or promote products derived
     from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGE. */

/* $Id: frexp.S,v 1.8 2007/01/14 15:10:25 dmix Exp $ */

#include "fp32def.h"
#include "asmdef.h"

/* float frexp (float x, int *pexp);
     The frexp() function is used to split the number x into a normalized
     fraction and an exponent which is stored in pexp.
 */

#define	pexp_lo	r20

ENTRY frexp

	X_movw	ZL, pexp_lo

	rcall	_U(__fp_splitA)
	brcs	.L_nf
	tst	rA3
	breq	.L_zr
	subi	rA3, 126
	sbc	rB3, rB3

	sbrs	rA2, 7
	rcall	_U(__fp_norm2)

	st	Z, rA3
	std	Z+1, rB3
	andi	rA2, 0x7f
	ldi	rA3, 0x3f
3:	bld	rA3, 7
	ret
.L_nf:
	rjmp	_U(__fp_mpack)
.L_zr:
	st	Z, r1
	std	Z+1, r1
	rjmp	3b
ENDFUNC
